Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Rice Pastry API
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mpisws.p2p.transport.limitsockets
Class LimitSocketsTransportLayer<Identifier,MessageType>

    java.lang.Object
      org.mpisws.p2p.transport.limitsockets.LimitSocketsTransportLayer<Identifier,MessageType>

All Implemented Interfaces:
  TransportLayer<Identifier,MessageType>, TransportLayerCallback<Identifier,MessageType>, Destructable

    public class LimitSocketsTransportLayer<Identifier,MessageType>

extends java.lang.Object
implements TransportLayer<Identifier,MessageType>, TransportLayerCallback<Identifier,MessageType>

Automatically closes sockets based on LRU. Uses the LinkedHashMap to perfrom the LRU policy.

Author:
  Jeff Hoye

Field Summary
`protected java.util.LinkedHashMap<org.mpisws.p2p.transport.limitsockets.LimitSocketsTransportLayer.LSSocket,org.mpisws.p2p.transport.limitsockets.LimitSocketsTransportLayer.LSSocket>` | `cache`
`protected TransportLayerCallback<Identifier,MessageType>` | `callback`
`protected ErrorHandler<Identifier>` | `handler`
`protected Logger` | `logger`
`protected Timer` | `timer`
`protected TransportLayer<Identifier,MessageType>` | `tl`

Constructor Summary
`LimitSocketsTransportLayer(int max_sockets, TransportLayer<Identifier,MessageType> tl, ErrorHandler<Identifier> handler, Environment env)`

Method Summary
`void` | `acceptMessages(boolean b)` Toggle accepting incoming messages.
`void` | `acceptSockets(boolean b)` Toggle accepting new sockets.
`protected void` | `closeIfNecessary()`
`void` | `destroy()`
`Identifier` | `getLocalIdentifier()` The local node.
`protected org.mpisws.p2p.transport.limitsockets.LimitSocketsTransportLayer.LSSocket` | `getLSSock(P2PSocket<Identifier> sock)`
`void` | `incomingSocket(P2PSocket<Identifier> s)` Notification of a new socket.
`void` | `messageReceived(Identifier i, MessageType m, java.util.Map<java.lang.String,java.lang.Object> options)` Called when a new message is received.
`SocketRequestHandle<Identifier>` | `openSocket(Identifier i, SocketCallback<Identifier> deliverSocketToMe, java.util.Map<java.lang.String,java.lang.Object> options)` Open a socket to the Identifier
`MessageRequestHandle<Identifier,MessageType>` | `sendMessage(Identifier i, MessageType m, MessageCallback<Identifier,MessageType> deliverAckToMe, java.util.Map<java.lang.String,java.lang.Object> options)` Send the message to the identifier
`void` | `setCallback(TransportLayerCallback<Identifier,MessageType> callback)` Set the callback for incoming sockets/messages
`void` | `setErrorHandler(ErrorHandler<Identifier> handler)` To be notified of problems not related to an outgoing messaage/socket.
`java.lang.String` | `toString()`
`void` | `touch(org.mpisws.p2p.transport.limitsockets.LimitSocketsTransportLayer.LSSocket socket)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### tl

    protected TransportLayer<Identifier,MessageType> tl

### cache

    protected java.util.LinkedHashMap<org.mpisws.p2p.transport.limitsockets.LimitSocketsTransportLayer.LSSocket,org.mpisws.p2p.transport.limitsockets.LimitSocketsTransportLayer.LSSocket> cache

### logger

    protected Logger logger

### callback

    protected TransportLayerCallback<Identifier,MessageType> callback

### timer

    protected Timer timer

### handler

    protected ErrorHandler<Identifier> handler

Constructor Detail

### LimitSocketsTransportLayer

    public LimitSocketsTransportLayer(int max_sockets,
                                      TransportLayer<Identifier,MessageType> tl,
                                      ErrorHandler<Identifier> handler,
                                      Environment env)

Method Detail

### openSocket

    public SocketRequestHandle<Identifier> openSocket(Identifier i,
                                                      SocketCallback<Identifier> deliverSocketToMe,
                                                      java.util.Map<java.lang.String,java.lang.Object> options)

  Description copied from interface: `TransportLayer`
  Open a socket to the Identifier

  Specified by:
    `openSocket` in interface `TransportLayer<Identifier,MessageType>`
  Parameters:
    `i` - who to open the socket to
    `deliverSocketToMe` - the callback when the socket is opened
    `options` - options on how to open the socket (don't source route, encrypt etc) (may not be respected if layer cannot provide service)
  Returns:
    an object to cancel opening the socket if it takes to long, or is no longer relevant

### incomingSocket

    public void incomingSocket(P2PSocket<Identifier> s)
                        throws java.io.IOException

  Description copied from interface: `TransportLayerCallback`
  Notification of a new socket.

  Specified by:
    `incomingSocket` in interface `TransportLayerCallback<Identifier,MessageType>`
  Parameters:
    `s` - the incoming socket
  Throws:
    `java.io.IOException`

### getLSSock

    protected org.mpisws.p2p.transport.limitsockets.LimitSocketsTransportLayer.LSSocket getLSSock(P2PSocket<Identifier> sock)

### closeIfNecessary

    protected void closeIfNecessary()

### touch

    public void touch(org.mpisws.p2p.transport.limitsockets.LimitSocketsTransportLayer.LSSocket socket)

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### acceptMessages

    public void acceptMessages(boolean b)

  Description copied from interface: `TransportLayer`
  Toggle accepting incoming messages. Useful in flow control if overwhelmed by incoming sockets. Default: true

  Specified by:
    `acceptMessages` in interface `TransportLayer<Identifier,MessageType>`

### acceptSockets

    public void acceptSockets(boolean b)

  Description copied from interface: `TransportLayer`
  Toggle accepting new sockets. Useful in flow control if overwhelmed by incoming sockets. Default: true

  Specified by:
    `acceptSockets` in interface `TransportLayer<Identifier,MessageType>`

### getLocalIdentifier

    public Identifier getLocalIdentifier()

  Description copied from interface: `TransportLayer`
  The local node.

  Specified by:
    `getLocalIdentifier` in interface `TransportLayer<Identifier,MessageType>`
  Returns:
    The local node.

### sendMessage

    public MessageRequestHandle<Identifier,MessageType> sendMessage(Identifier i,
                                                                    MessageType m,
                                                                    MessageCallback<Identifier,MessageType> deliverAckToMe,
                                                                    java.util.Map<java.lang.String,java.lang.Object> options)

  Description copied from interface: `TransportLayer`
  Send the message to the identifier

  Specified by:
    `sendMessage` in interface `TransportLayer<Identifier,MessageType>`
  Parameters:
    `i` - the destination
    `m` - the message
    `deliverAckToMe` - layer dependent notification when the message is sent (can indicate placed on the wire, point-to-point acknowledgment, or end-to-end acknowledgement)
    `options` - delivery options (don't source route, encrypt etc) (may not be respected if layer cannot provide service)
  Returns:
    ability to cancel the message if no longer relevant

### messageReceived

    public void messageReceived(Identifier i,
                                MessageType m,
                                java.util.Map<java.lang.String,java.lang.Object> options)
                         throws java.io.IOException

  Description copied from interface: `TransportLayerCallback`
  Called when a new message is received.

  Specified by:
    `messageReceived` in interface `TransportLayerCallback<Identifier,MessageType>`
  Parameters:
    `i` - The node it is coming from
    `m` - the message
    `options` - describe how the message arrived (udp/tcp, encrypted etc)
  Throws:
    `java.io.IOException` - if there is a problem decoding the message

### setCallback

    public void setCallback(TransportLayerCallback<Identifier,MessageType> callback)

  Description copied from interface: `TransportLayer`
  Set the callback for incoming sockets/messages

  Specified by:
    `setCallback` in interface `TransportLayer<Identifier,MessageType>`
  Parameters:
    `callback` - the callback for incoming sockets/messages

### setErrorHandler

    public void setErrorHandler(ErrorHandler<Identifier> handler)

  Description copied from interface: `TransportLayer`
  To be notified of problems not related to an outgoing messaage/socket. Or to be notified if a callback isn't provided.

  Specified by:
    `setErrorHandler` in interface `TransportLayer<Identifier,MessageType>`
  Parameters:
    `handler` - to be notified of problems not related to a specific messaage/socket.

### destroy

    public void destroy()

  Specified by:
    `destroy` in interface `Destructable`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Rice Pastry API
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2005 - Rice Pastry.